Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/sleep.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/sleep.c	(revision 374)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/sleep.c	(revision 374)
@@ -0,0 +1,199 @@
+/* mbed Microcontroller Library
+ * Copyright (c) 2018 ARM Limited
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+#include "sleep_api.h"
+#include "cmsis.h"
+#include "mbed_interface.h"
+#include "mbed_critical.h"
+#include "iodefine.h"
+#include "cpg_iobitmask.h"
+
+#if DEVICE_SLEEP
+static volatile uint8_t wk_CPGSTBCR3;
+static volatile uint8_t wk_CPGSTBCR4;
+static volatile uint8_t wk_CPGSTBCR5;
+static volatile uint8_t wk_CPGSTBCR6;
+static volatile uint8_t wk_CPGSTBCR7;
+static volatile uint8_t wk_CPGSTBCR8;
+static volatile uint8_t wk_CPGSTBCR9;
+static volatile uint8_t wk_CPGSTBCR10;
+static volatile uint8_t wk_CPGSTBCR11;
+static volatile uint8_t wk_CPGSTBCR12;
+#if defined(TARGET_RZA1H)  || defined(TARGET_VK_RZ_A1H)
+static volatile uint8_t wk_CPGSTBCR13;
+#endif
+static volatile uint8_t wk_CPGSTBREQ1;
+static volatile uint8_t wk_CPGSTBREQ2;
+
+typedef struct {
+    volatile uint8_t * p_wk_stbcr;
+    volatile uint8_t * p_stbcr;
+    volatile uint8_t * p_stbreq;
+    volatile uint8_t * p_stback;
+    uint8_t mstp;
+    uint8_t stbrq;
+} module_stanby_t;
+
+static const module_stanby_t module_stanby[] = {
+    {&wk_CPGSTBCR6,  &CPGSTBCR6,  &CPGSTBREQ1, &CPGSTBACK1, CPG_STBCR6_MSTP61,   CPG_STBREQ1_STBRQ13}, /* JCU */
+    {&wk_CPGSTBCR6,  &CPGSTBCR6,  &CPGSTBREQ1, &CPGSTBACK1, CPG_STBCR6_MSTP66,   CPG_STBREQ1_STBRQ10}, /* CEU */
+    {&wk_CPGSTBCR6,  &CPGSTBCR8,  &CPGSTBREQ1, &CPGSTBACK1, CPG_STBCR8_MSTP82,   CPG_STBREQ1_STBRQ12}, /* EthernetAVB */
+    {&wk_CPGSTBCR7,  &CPGSTBCR7,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR7_MSTP74,   CPG_STBREQ2_STBRQ26}, /* Ethernet */
+    {&wk_CPGSTBCR8,  &CPGSTBCR8,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR8_MSTP83,   CPG_STBREQ2_STBRQ27}, /* MediaLB */
+    {&wk_CPGSTBCR9,  &CPGSTBCR9,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR9_MSTP91,   CPG_STBREQ2_STBRQ25}, /* VDC5_0 */
+#if defined(TARGET_RZA1H)  || defined(TARGET_VK_RZ_A1H)
+    {&wk_CPGSTBCR8,  &CPGSTBCR8,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR8_MSTP85,   CPG_STBREQ2_STBRQ21}, /* IMR-LSD */
+    {&wk_CPGSTBCR8,  &CPGSTBCR8,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR8_MSTP86,   CPG_STBREQ2_STBRQ22}, /* IMR-LS2_1 */
+    {&wk_CPGSTBCR8,  &CPGSTBCR8,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR8_MSTP87,   CPG_STBREQ2_STBRQ23}, /* IMR-LS2_0 */
+    {&wk_CPGSTBCR9,  &CPGSTBCR9,  &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR9_MSTP90,   CPG_STBREQ2_STBRQ24}, /* VDC5_1 */
+    {&wk_CPGSTBCR10, &CPGSTBCR10, &CPGSTBREQ2, &CPGSTBACK2, CPG_STBCR10_MSTP100, CPG_STBREQ2_STBRQ20}, /* OpenVG */
+#endif
+    {0, 0, 0, 0, 0}  /* None */
+};
+
+static void module_standby_in(void) {
+    volatile uint32_t cnt;
+    volatile uint8_t dummy_8;
+    const module_stanby_t * p_module = &module_stanby[0];
+
+    while (p_module->p_wk_stbcr != 0) {
+        if ((*p_module->p_wk_stbcr & p_module->mstp) == 0) {
+            *p_module->p_stbreq |= p_module->stbrq;
+            dummy_8             = *p_module->p_stbreq;
+            for (cnt = 0; cnt < 1000; cnt++) {      // wait time
+                if ((*p_module->p_stback & p_module->stbrq) != 0) {
+                    break;
+                }
+            }
+            *p_module->p_stbcr |= p_module->mstp;
+            dummy_8            = *p_module->p_stbcr;
+        }
+        p_module++;
+    }
+    (void)dummy_8;
+}
+
+static void module_standby_out(void) {
+    volatile uint32_t cnt;
+    volatile uint8_t dummy_8;
+    const module_stanby_t * p_module = &module_stanby[0];
+
+    while (p_module->p_wk_stbcr != 0) {
+        if ((*p_module->p_wk_stbcr & p_module->mstp) == 0) {
+            *p_module->p_stbreq &= ~(p_module->stbrq);
+            dummy_8             = *p_module->p_stbreq;
+            for (cnt = 0; cnt < 1000; cnt++) {
+                if ((*p_module->p_stback & p_module->stbrq) == 0) {
+                    break;
+                }
+            }
+        }
+        p_module++;
+    }
+    (void)dummy_8;
+}
+
+void hal_sleep(void) {
+    // Transition to Sleep Mode
+    __WFI();
+}
+
+void hal_deepsleep(void) {
+    volatile uint8_t dummy_8;
+
+    core_util_critical_section_enter();
+    /* For powerdown the peripheral module, save current standby control register values(just in case) */
+    wk_CPGSTBCR3  = CPGSTBCR3;
+    wk_CPGSTBCR4  = CPGSTBCR4;
+    wk_CPGSTBCR5  = CPGSTBCR5;
+    wk_CPGSTBCR6  = CPGSTBCR6;
+    wk_CPGSTBCR7  = CPGSTBCR7;
+    wk_CPGSTBCR8  = CPGSTBCR8;
+    wk_CPGSTBCR9  = CPGSTBCR9;
+    wk_CPGSTBCR10 = CPGSTBCR10;
+    wk_CPGSTBCR11 = CPGSTBCR11;
+    wk_CPGSTBCR12 = CPGSTBCR12;
+#if defined(TARGET_RZA1H)  || defined(TARGET_VK_RZ_A1H)
+    wk_CPGSTBCR13 = CPGSTBCR13;
+#endif
+
+    /* MTU2 (for low power ticker) */
+    CPGSTBCR3  |= ~(CPG_STBCR3_MSTP33);
+    dummy_8    = CPGSTBCR3;
+    CPGSTBCR4  = 0xFF;
+    dummy_8    = CPGSTBCR4;
+    CPGSTBCR5  = 0xFF;
+    dummy_8    = CPGSTBCR5;
+    /* Realtime Clock, JCU, CEU */
+    CPGSTBCR6  |= ~(CPG_STBCR6_MSTP60 | CPG_STBCR6_MSTP61 | CPG_STBCR6_MSTP66);
+    dummy_8    = CPGSTBCR6;
+    /* Video Decoder0, Video Decoder1, Ethernet */
+    CPGSTBCR7  |= ~(CPG_STBCR7_MSTP77 | CPG_STBCR7_MSTP76 | CPG_STBCR7_MSTP74);
+    dummy_8    = CPGSTBCR7;
+    /* EthernetAVB, MediaLB, IMR-LSD, IMR-LS2_1, IMR-LS2_0 */
+    CPGSTBCR8  |= ~(CPG_STBCR8_MSTP82 | CPG_STBCR8_MSTP83 | CPG_STBCR8_MSTP85 | CPG_STBCR8_MSTP86 | CPG_STBCR8_MSTP87);
+    dummy_8    = CPGSTBCR8;
+    /* VDC5_1, SPI Multi I/O Bus Controller0 */
+    CPGSTBCR9  |= ~(CPG_STBCR9_MSTP90 | CPG_STBCR9_MSTP93);
+    dummy_8    = CPGSTBCR9;
+    /* OpenVG */
+    CPGSTBCR10 |= ~(CPG_STBCR10_MSTP100);
+    dummy_8    = CPGSTBCR10;
+    CPGSTBCR11 = 0xFF;
+    dummy_8    = CPGSTBCR11;
+    CPGSTBCR12 = 0xFF;
+    dummy_8    = CPGSTBCR12;
+#if defined(TARGET_RZA1H)  || defined(TARGET_VK_RZ_A1H)
+    CPGSTBCR13 = 0xFF;
+    dummy_8    = CPGSTBCR13;
+#endif
+
+    module_standby_in();
+
+    // Transition to Sleep Mode
+    __WFI();
+
+    /* Revert standby control register values */
+    CPGSTBCR3  = wk_CPGSTBCR3;
+    dummy_8    = CPGSTBCR3;
+    CPGSTBCR4  = wk_CPGSTBCR4;
+    dummy_8    = CPGSTBCR4;
+    CPGSTBCR5  = wk_CPGSTBCR5;
+    dummy_8    = CPGSTBCR5;
+    CPGSTBCR6  = wk_CPGSTBCR6;
+    dummy_8    = CPGSTBCR6;
+    CPGSTBCR7  = wk_CPGSTBCR7;
+    dummy_8    = CPGSTBCR7;
+    CPGSTBCR8  = wk_CPGSTBCR8;
+    dummy_8    = CPGSTBCR8;
+    CPGSTBCR9  = wk_CPGSTBCR9;
+    dummy_8    = CPGSTBCR9;
+    CPGSTBCR10 = wk_CPGSTBCR10;
+    dummy_8    = CPGSTBCR10;
+    CPGSTBCR11 = wk_CPGSTBCR11;
+    dummy_8    = CPGSTBCR11;
+    CPGSTBCR12 = wk_CPGSTBCR12;
+    dummy_8    = CPGSTBCR12;
+#if defined(TARGET_RZA1H)  || defined(TARGET_VK_RZ_A1H)
+    CPGSTBCR13 = wk_CPGSTBCR13;
+    dummy_8    = CPGSTBCR13;
+#endif
+
+    module_standby_out();
+    core_util_critical_section_exit();
+
+    (void)dummy_8;
+}
+#endif
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spi_api.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spi_api.c	(revision 374)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spi_api.c	(revision 374)
@@ -0,0 +1,536 @@
+/* mbed Microcontroller Library
+ * Copyright (c) 2006-2013 ARM Limited
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+#include "mbed_assert.h"
+#include <math.h>
+
+#include "spi_api.h"
+#include "cmsis.h"
+#include "PeripheralPins.h"
+#include "mbed_error.h"
+#include "RZ_A1_Init.h"
+#include "mbed_drv_cfg.h"
+
+static const struct st_rspi *RSPI[] = RSPI_ADDRESS_LIST;
+
+static inline void spi_disable(spi_t *obj);
+static inline void spi_enable(spi_t *obj);
+static inline int spi_readable(spi_t *obj);
+static inline void spi_write(spi_t *obj, int value);
+static inline int spi_read(spi_t *obj);
+
+void spi_init(spi_t *obj, PinName mosi, PinName miso, PinName sclk, PinName ssel) {
+    // determine the SPI to use
+    volatile uint8_t dummy;
+    uint32_t spi_mosi = pinmap_peripheral(mosi, PinMap_SPI_MOSI);
+    uint32_t spi_miso = pinmap_peripheral(miso, PinMap_SPI_MISO);
+    uint32_t spi_sclk = pinmap_peripheral(sclk, PinMap_SPI_SCLK);
+    uint32_t spi_ssel = pinmap_peripheral(ssel, PinMap_SPI_SSEL);
+    uint32_t spi_data = pinmap_merge(spi_mosi, spi_miso);
+    uint32_t spi_cntl = pinmap_merge(spi_sclk, spi_ssel);
+    uint32_t spi      = pinmap_merge(spi_data, spi_cntl);
+    
+    MBED_ASSERT((int)spi != NC);
+    
+    obj->spi.spi = (struct st_rspi *)RSPI[spi];
+    obj->spi.index = spi;
+    
+    // enable power and clocking
+    CPGSTBCR10 &= ~(0x80 >> spi);
+    dummy = CPGSTBCR10;
+    (void)dummy;
+    
+    obj->spi.spi->SPCR   = 0x00;  // CTRL to 0
+    obj->spi.spi->SPSCR  = 0x00;  // no sequential operation
+    obj->spi.spi->SSLP   = 0x00;  // SSL 'L' active
+    obj->spi.spi->SPDCR  = 0x20;  // byte access
+    obj->spi.spi->SPCKD  = 0x00;  // SSL -> enable CLK delay : 1RSPCK
+    obj->spi.spi->SSLND  = 0x00;  // CLK end -> SSL neg delay : 1RSPCK
+    obj->spi.spi->SPND   = 0x00;  // delay between CMD : 1RSPCK + 2P1CLK
+    obj->spi.spi->SPPCR  = 0x20;  // MOSI Idle fixed value equals 0
+    obj->spi.spi->SPBFCR = 0xf0;  // and set trigger count: read 1, write 1
+    obj->spi.spi->SPBFCR = 0x30;  // and reset buffer
+    
+    // pin out the spi pins
+    pinmap_pinout(mosi, PinMap_SPI_MOSI);
+    pinmap_pinout(miso, PinMap_SPI_MISO);
+    pinmap_pinout(sclk, PinMap_SPI_SCLK);
+    if ((int)ssel != NC) {
+        pinmap_pinout(ssel, PinMap_SPI_SSEL);
+    }
+}
+
+void spi_free(spi_t *obj) {}
+
+void spi_format(spi_t *obj, int bits, int mode, int slave) {
+    int      DSS;      // DSS (data select size)
+    int      polarity  = (mode & 0x2) ? 1 : 0;
+    int      phase     = (mode & 0x1) ? 1 : 0;
+    uint16_t tmp       = 0;
+    uint16_t mask      = 0xf03;
+    uint16_t wk_spcmd0;
+    uint8_t  splw;
+    
+    switch (mode) {
+        case 0:
+        case 1:
+        case 2:
+        case 3:
+            // Do Nothing
+            break;
+        default:
+            error("SPI format error");
+            return;
+    }
+    
+    switch (bits) {
+        case 8:
+            DSS  = 0x7;
+            splw = 0x20;
+            break;
+        case 16:
+            DSS  = 0xf;
+            splw = 0x40;
+            break;
+        case 32:
+            DSS  = 0x2;
+            splw = 0x60;
+            break;
+        default:
+            error("SPI module don't support other than 8/16/32bits");
+            return;
+    }
+    tmp |= phase;
+    tmp |= (polarity << 1);
+    tmp |= (DSS << 8);
+    obj->spi.bits = bits;
+    
+    spi_disable(obj);
+    wk_spcmd0 = obj->spi.spi->SPCMD0;
+    wk_spcmd0 &= ~mask;
+    wk_spcmd0 |= (mask & tmp);
+    obj->spi.spi->SPCMD0 = wk_spcmd0;
+    obj->spi.spi->SPDCR   = splw;
+    if (slave) {
+        obj->spi.spi->SPCR &=~(1 << 3);  // MSTR to 0
+    } else {
+        obj->spi.spi->SPCR |= (1 << 3);  // MSTR to 1
+    }
+    spi_enable(obj);
+}
+
+void spi_frequency(spi_t *obj, int hz) {
+    uint32_t  pclk_base;
+    uint32_t  div;
+    uint32_t  brdv = 0;
+    uint32_t  hz_max;
+    uint32_t  hz_min;
+    uint16_t  mask = 0x000c;
+    uint16_t  wk_spcmd0;
+    
+    /* set PCLK */
+    if (RZ_A1_IsClockMode0() == false) {
+        pclk_base = CM1_RENESAS_RZ_A1_P1_CLK;
+    } else {
+        pclk_base = CM0_RENESAS_RZ_A1_P1_CLK;
+    }
+    
+    hz_min = pclk_base / 2 / 256 / 8;
+    hz_max = pclk_base / 2;
+    if (((uint32_t)hz < hz_min) || ((uint32_t)hz > hz_max)) {
+        error("Couldn't setup requested SPI frequency");
+        return;
+    }
+    
+    div = (pclk_base / hz / 2);
+    while (div > 256) {
+        div >>= 1;
+        brdv++;
+    }
+    div  -= 1;
+    brdv  = (brdv << 2);
+    
+    spi_disable(obj);
+    obj->spi.spi->SPBR = div;
+    wk_spcmd0 = obj->spi.spi->SPCMD0;
+    wk_spcmd0 &= ~mask;
+    wk_spcmd0 |= (mask & brdv);
+    obj->spi.spi->SPCMD0 = wk_spcmd0;
+    spi_enable(obj);
+}
+
+static inline void spi_disable(spi_t *obj) {
+    obj->spi.spi->SPCR &= ~(1 << 6);       // SPE to 0
+}
+
+static inline void spi_enable(spi_t *obj) {
+    obj->spi.spi->SPCR |=  (1 << 6);       // SPE to 1
+}
+
+static inline int spi_readable(spi_t *obj) {
+    return obj->spi.spi->SPSR & (1 << 7);  // SPRF
+}
+
+static inline int spi_tend(spi_t *obj) {
+    return obj->spi.spi->SPSR & (1 << 6);  // TEND
+}
+
+static inline void spi_write(spi_t *obj, int value) {
+    if (obj->spi.bits == 8) {
+        obj->spi.spi->SPDR.UINT8[0]  = (uint8_t)value;
+    } else if (obj->spi.bits == 16) {
+        obj->spi.spi->SPDR.UINT16[0] = (uint16_t)value;
+    } else {
+        obj->spi.spi->SPDR.UINT32    = (uint32_t)value;
+    }
+}
+
+static inline int spi_read(spi_t *obj) {
+    int read_data;
+    
+    if (obj->spi.bits == 8) {
+        read_data = obj->spi.spi->SPDR.UINT8[0];
+    } else if (obj->spi.bits == 16) {
+        read_data = obj->spi.spi->SPDR.UINT16[0];
+    } else {
+        read_data = obj->spi.spi->SPDR.UINT32;
+    }
+    
+    return read_data;
+}
+
+int spi_master_write(spi_t *obj, int value) {
+    spi_write(obj, value);
+    while(!spi_tend(obj));
+    return spi_read(obj);
+}
+
+int spi_master_block_write(spi_t *obj, const char *tx_buffer, int tx_length,
+                           char *rx_buffer, int rx_length, char write_fill) {
+    int total = (tx_length > rx_length) ? tx_length : rx_length;
+
+    for (int i = 0; i < total; i++) {
+        char out = (i < tx_length) ? tx_buffer[i] : write_fill;
+        char in = spi_master_write(obj, out);
+        if (i < rx_length) {
+            rx_buffer[i] = in;
+        }
+    }
+
+    return total;
+}
+
+int spi_slave_receive(spi_t *obj) {
+    return (spi_readable(obj) && !spi_busy(obj)) ? (1) : (0);
+}
+
+int spi_slave_read(spi_t *obj) {
+    return spi_read(obj);
+}
+
+void spi_slave_write(spi_t *obj, int value) {
+    spi_write(obj, value);
+}
+
+int spi_busy(spi_t *obj) {
+    return 0;
+}
+
+#if DEVICE_SPI_ASYNCH
+
+#define SPI_NUM         5
+#define IRQ_NUM         2
+
+static void spi_irqs_set(spi_t *obj, uint32_t enable);
+static void spi_async_write(spi_t *obj);
+static void spi_async_read(spi_t *obj);
+
+static void spi0_rx_irq(void);
+static void spi0_er_irq(void);
+static void spi1_rx_irq(void);
+static void spi1_er_irq(void);
+static void spi2_rx_irq(void);
+static void spi2_er_irq(void);
+static void spi3_rx_irq(void);
+static void spi3_er_irq(void);
+static void spi4_rx_irq(void);
+static void spi4_er_irq(void);
+
+static const IRQn_Type irq_set_tbl[SPI_NUM][IRQ_NUM] = {
+    {RSPISPRI0_IRQn, RSPISPEI0_IRQn},
+    {RSPISPRI1_IRQn, RSPISPEI1_IRQn},
+    {RSPISPRI2_IRQn, RSPISPEI2_IRQn},
+    {RSPISPRI3_IRQn, RSPISPEI3_IRQn},
+    {RSPISPRI4_IRQn, RSPISPEI4_IRQn},
+};
+
+static const IRQHandler hander_set_tbl[SPI_NUM][IRQ_NUM] = {
+    {spi0_rx_irq, spi0_er_irq},
+    {spi1_rx_irq, spi1_er_irq},
+    {spi2_rx_irq, spi2_er_irq},
+    {spi3_rx_irq, spi3_er_irq},
+    {spi4_rx_irq, spi4_er_irq},
+};
+
+struct spi_global_data_s {
+    spi_t *async_obj;
+    uint32_t async_callback, event, wanted_events;
+};
+
+static struct spi_global_data_s spi_data[SPI_NUM];
+
+static void spi_rx_irq(IRQn_Type irq_num, uint32_t index)
+{
+    spi_t *obj = spi_data[index].async_obj;
+    if (obj->rx_buff.buffer && obj->rx_buff.pos < obj->rx_buff.length) {
+        spi_async_read(obj);
+    } else {
+        if (obj->rx_buff.buffer && obj->tx_buff.buffer && obj->tx_buff.pos < obj->tx_buff.length) {
+            spi_data[obj->spi.index].event = SPI_EVENT_INTERNAL_TRANSFER_COMPLETE;
+            if (spi_data[obj->spi.index].wanted_events & SPI_EVENT_COMPLETE) {
+                spi_data[obj->spi.index].event |= SPI_EVENT_COMPLETE;
+            }
+            spi_irqs_set(obj, 0);
+            spi_data[obj->spi.index].async_obj = NULL;
+            ((void (*)())spi_data[obj->spi.index].async_callback)();
+            return;
+        }
+        spi_read(obj);
+    }
+    if (obj->tx_buff.buffer) {
+        if (obj->tx_buff.pos == obj->tx_buff.length) {
+            spi_data[obj->spi.index].event = SPI_EVENT_INTERNAL_TRANSFER_COMPLETE;
+            if (spi_data[obj->spi.index].wanted_events & SPI_EVENT_COMPLETE) {
+                spi_data[obj->spi.index].event |= SPI_EVENT_COMPLETE;
+            }
+            spi_irqs_set(obj, 0);
+            spi_data[obj->spi.index].async_obj = NULL;
+            ((void (*)())spi_data[obj->spi.index].async_callback)();
+        } else {
+            spi_async_write(obj);
+        }
+    } else {
+        if (obj->rx_buff.pos == obj->rx_buff.length) {
+            spi_data[obj->spi.index].event = SPI_EVENT_INTERNAL_TRANSFER_COMPLETE;
+            if (spi_data[obj->spi.index].wanted_events & SPI_EVENT_COMPLETE) {
+                spi_data[obj->spi.index].event |= SPI_EVENT_COMPLETE;
+            }
+            spi_irqs_set(obj, 0);
+            spi_data[obj->spi.index].async_obj = NULL;
+            ((void (*)())spi_data[obj->spi.index].async_callback)();
+        } else {
+            spi_async_write(obj);
+        }
+    }
+}
+
+static void spi_err_irq(IRQn_Type irq_num, uint32_t index)
+{
+    spi_t *obj = spi_data[index].async_obj;
+    spi_abort_asynch(obj);
+    spi_data[index].event = SPI_EVENT_ERROR;
+    if (spi_data[index].wanted_events & SPI_EVENT_ERROR) {
+        ((void (*)())spi_data[index].async_callback)();
+    }
+}
+
+static void spi0_rx_irq(void) {
+    spi_rx_irq(RSPISPRI0_IRQn, 0);
+}
+static void spi0_er_irq(void) {
+    spi_err_irq(RSPISPEI0_IRQn, 0);
+}
+static void spi1_rx_irq(void) {
+    spi_rx_irq(RSPISPRI1_IRQn, 1);
+}
+static void spi1_er_irq(void) {
+    spi_err_irq(RSPISPEI1_IRQn, 1);
+}
+static void spi2_rx_irq(void) {
+    spi_rx_irq(RSPISPRI2_IRQn, 2);
+}
+static void spi2_er_irq(void) {
+    spi_err_irq(RSPISPEI2_IRQn, 2);
+}
+static void spi3_rx_irq(void) {
+    spi_rx_irq(RSPISPRI3_IRQn, 3);
+}
+static void spi3_er_irq(void) {
+    spi_err_irq(RSPISPEI3_IRQn, 3);
+}
+static void spi4_rx_irq(void) {
+    spi_rx_irq(RSPISPRI4_IRQn, 4);
+}
+static void spi4_er_irq(void) {
+    spi_err_irq(RSPISPEI4_IRQn, 4);
+}
+
+static void spi_irqs_set(spi_t *obj, uint32_t enable)
+{
+    int i;
+    const IRQn_Type *irqTable = irq_set_tbl[obj->spi.index];
+    const IRQHandler *handlerTable = hander_set_tbl[obj->spi.index];
+    for (i = 0; i < IRQ_NUM; ++i) {
+        if (enable) {
+            InterruptHandlerRegister(irqTable[i], handlerTable[i]);
+            GIC_SetPriority(irqTable[i], 5);
+            GIC_SetConfiguration(irqTable[i], 1);
+            GIC_EnableIRQ(irqTable[i]);
+        } else {
+            GIC_DisableIRQ(irqTable[i]);
+        }
+    }
+    if (enable) {
+        obj->spi.spi->SPCR |= (1 << 4) | (1 << 7);
+    } else {
+        obj->spi.spi->SPCR &= ~((1 << 4) | (1 << 7));
+    }
+}
+
+static void spi_async_write(spi_t *obj)
+{
+    uint8_t **width8;
+    uint16_t **width16;
+    uint32_t **width32;
+    
+    if (obj->tx_buff.buffer) {
+        switch (obj->tx_buff.width) {
+            case 8:
+                width8 = (uint8_t **)&obj->tx_buff.buffer;
+                spi_write(obj, **width8);
+                ++*width8;
+                obj->tx_buff.pos += sizeof(uint8_t);
+                break;
+                
+            case 16:
+                width16 = (uint16_t **)&obj->tx_buff.buffer;
+                spi_write(obj, **width16);
+                ++*width16;
+                obj->tx_buff.pos += sizeof(uint16_t);
+                break;
+                
+            case 32:
+                width32 = (uint32_t **)&obj->tx_buff.buffer;
+                spi_write(obj, **width32);
+                ++*width32;
+                obj->tx_buff.pos += sizeof(uint32_t);
+                break;
+                
+            default:
+                MBED_ASSERT(0);
+                break;
+        }
+    } else {
+        spi_write(obj, SPI_FILL_WORD);
+    }
+}
+
+static void spi_async_read(spi_t *obj)
+{
+    uint8_t **width8;
+    uint16_t **width16;
+    uint32_t **width32;
+    
+    switch (obj->rx_buff.width) {
+        case 8:
+            width8 = (uint8_t **)&obj->rx_buff.buffer;
+            **width8 = spi_read(obj);
+            ++*width8;
+            obj->rx_buff.pos += sizeof(uint8_t);
+            break;
+            
+        case 16:
+            width16 = (uint16_t **)&obj->rx_buff.buffer;
+            **width16 = spi_read(obj);
+            ++*width16;
+            obj->rx_buff.pos += sizeof(uint16_t);
+            break;
+            
+        case 32:
+            width32 = (uint32_t **)&obj->rx_buff.buffer;
+            **width32 = spi_read(obj);
+            ++*width32;
+            obj->rx_buff.pos += sizeof(uint32_t);
+            break;
+            
+        default:
+            MBED_ASSERT(0);
+            break;
+    }
+}
+
+/******************************************************************************
+ * ASYNCHRONOUS HAL
+ ******************************************************************************/
+
+void spi_master_transfer(spi_t *obj, const void *tx, size_t tx_length, void *rx, size_t rx_length, uint8_t bit_width, uint32_t handler, uint32_t event, DMAUsage hint)
+{
+    int i;
+    MBED_ASSERT(obj);
+    MBED_ASSERT(tx || rx);
+    MBED_ASSERT(tx && ! rx ? tx_length : 1);
+    MBED_ASSERT(rx && ! tx ? rx_length : 1);
+    MBED_ASSERT(obj->spi.spi->SPCR & (1 << 3)); /* Slave mode */
+    MBED_ASSERT(bit_width == 8 || bit_width == 16 || bit_width == 32);
+    
+    if (tx_length) {
+        obj->tx_buff.buffer = (void *)tx;
+    } else {
+        obj->tx_buff.buffer = NULL;
+    }
+    obj->tx_buff.length = tx_length * bit_width / 8;
+    obj->tx_buff.pos = 0;
+    obj->tx_buff.width = bit_width;
+    if (rx_length) {
+        obj->rx_buff.buffer = rx;
+    } else {
+        obj->rx_buff.buffer = NULL;
+    }
+    obj->rx_buff.length = rx_length * bit_width / 8;
+    obj->rx_buff.pos = 0;
+    obj->rx_buff.width = bit_width;
+    for (i = 0; i < (int)obj->rx_buff.length; i++) {
+        ((uint8_t *)obj->rx_buff.buffer)[i] = SPI_FILL_WORD;
+    }
+    
+    spi_data[obj->spi.index].async_callback = handler;
+    spi_data[obj->spi.index].async_obj = obj;
+    spi_data[obj->spi.index].event = 0;
+    spi_data[obj->spi.index].wanted_events = event;
+    
+    spi_irqs_set(obj, 1);
+    
+    spi_async_write(obj);
+}
+
+uint32_t spi_irq_handler_asynch(spi_t *obj)
+{
+    return spi_data[obj->spi.index].event;
+}
+
+uint8_t spi_active(spi_t *obj)
+{
+    return spi_data[obj->spi.index].async_obj != NULL;
+}
+
+void spi_abort_asynch(spi_t *obj)
+{
+    spi_disable(obj);
+    spi_irqs_set(obj, 0);
+    spi_data[obj->spi.index].async_obj = NULL;
+    spi_enable(obj);
+}
+
+#endif
Index: asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spibsc.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spibsc.h	(revision 374)
+++ asp3_tinet_ecnl_arm/trunk/asp3_dcre/mbed/targets/TARGET_RENESAS/TARGET_RZA1XX/spibsc.h	(revision 374)
@@ -0,0 +1,154 @@
+/*******************************************************************************
+* DISCLAIMER
+* This software is supplied by Renesas Electronics Corporation and is only
+* intended for use with Renesas products. No other uses are authorized. This
+* software is owned by Renesas Electronics Corporation and is protected under
+* all applicable laws, including copyright laws.
+* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
+* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
+* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
+* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
+* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
+* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
+* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
+* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
+* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
+* Renesas reserves the right, without notice, to make changes to this software
+* and to discontinue the availability of this software. By using this software,
+* you agree to the additional terms and conditions found by accessing the
+* following link:
+* http://www.renesas.com/disclaimer
+*
+* Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
+*******************************************************************************/
+/******************************************************************************
+* File Name    : spibsc.h
+* $Rev: 12 $
+* $Date:: 2016-05-19 17:26:37 +0900#$
+* Description  : 
+******************************************************************************/
+#ifndef _SPIBSC_H_
+#define _SPIBSC_H_
+
+/******************************************************************************
+Includes <System Includes> , "Project Includes"
+******************************************************************************/
+#include "iodefine.h"
+
+/******************************************************************************
+Macro definitions
+******************************************************************************/
+#define SPIBSC_CMNCR_MD_EXTRD       (0u)
+#define SPIBSC_CMNCR_MD_SPI         (1u)
+
+#define SPIBSC_OUTPUT_LOW           (0u)
+#define SPIBSC_OUTPUT_HIGH          (1u)
+#define SPIBSC_OUTPUT_LAST          (2u)
+#define SPIBSC_OUTPUT_HiZ           (3u)
+
+#define SPIBSC_CMNCR_CPHAT_EVEN     (0u)
+#define SPIBSC_CMNCR_CPHAT_ODD      (1u)
+
+#define SPIBSC_CMNCR_CPHAR_ODD      (0u)
+#define SPIBSC_CMNCR_CPHAR_EVEN     (1u)
+
+#define SPIBSC_CMNCR_SSLP_LOW       (0u)
+#define SPIBSC_CMNCR_SSLP_HIGH      (1u)
+
+#define SPIBSC_CMNCR_CPOL_LOW       (0u)
+#define SPIBSC_CMNCR_CPOL_HIGH      (1u)
+
+#define SPIBSC_CMNCR_BSZ_SINGLE     (0u)
+#define SPIBSC_CMNCR_BSZ_DUAL       (1u)
+
+#define SPIBSC_DELAY_1SPBCLK        (0u)
+#define SPIBSC_DELAY_2SPBCLK        (1u)
+#define SPIBSC_DELAY_3SPBCLK        (2u)
+#define SPIBSC_DELAY_4SPBCLK        (3u)
+#define SPIBSC_DELAY_5SPBCLK        (4u)
+#define SPIBSC_DELAY_6SPBCLK        (5u)
+#define SPIBSC_DELAY_7SPBCLK        (6u)
+#define SPIBSC_DELAY_8SPBCLK        (7u)
+
+
+#define SPIBSC_BURST_1              (0x00u)
+#define SPIBSC_BURST_2              (0x01u)
+#define SPIBSC_BURST_3              (0x02u)
+#define SPIBSC_BURST_4              (0x03u)
+#define SPIBSC_BURST_5              (0x04u)
+#define SPIBSC_BURST_6              (0x05u)
+#define SPIBSC_BURST_7              (0x06u)
+#define SPIBSC_BURST_8              (0x07u)
+#define SPIBSC_BURST_9              (0x08u)
+#define SPIBSC_BURST_10             (0x09u)
+#define SPIBSC_BURST_11             (0x0au)
+#define SPIBSC_BURST_12             (0x0bu)
+#define SPIBSC_BURST_13             (0x0cu)
+#define SPIBSC_BURST_14             (0x0du)
+#define SPIBSC_BURST_15             (0x0eu)
+#define SPIBSC_BURST_16             (0x0fu)
+
+#define SPIBSC_BURST_DISABLE        (0u)
+#define SPIBSC_BURST_ENABLE         (1u)
+
+#define SPIBSC_DRCR_RCF_EXE         (1u)
+
+#define SPIBSC_SSL_NEGATE           (0u)
+#define SPIBSC_TRANS_END            (1u)
+
+#define SPIBSC_1BIT                 (0u)
+#define SPIBSC_2BIT                 (1u)
+#define SPIBSC_4BIT                 (2u)
+
+#define SPIBSC_OUTPUT_DISABLE       (0u)
+#define SPIBSC_OUTPUT_ENABLE        (1u)
+#define SPIBSC_OUTPUT_ADDR_24       (0x07u)
+#define SPIBSC_OUTPUT_ADDR_32       (0x0fu)
+#define SPIBSC_OUTPUT_OPD_3         (0x08u)
+#define SPIBSC_OUTPUT_OPD_32        (0x0cu)
+#define SPIBSC_OUTPUT_OPD_321       (0x0eu)
+#define SPIBSC_OUTPUT_OPD_3210      (0x0fu)
+
+#define SPIBSC_OUTPUT_SPID_8        (0x08u)
+#define SPIBSC_OUTPUT_SPID_16       (0x0cu)
+#define SPIBSC_OUTPUT_SPID_32       (0x0fu)
+
+#define SPIBSC_SPISSL_NEGATE        (0u)
+#define SPIBSC_SPISSL_KEEP          (1u)
+
+#define SPIBSC_SPIDATA_DISABLE      (0u)
+#define SPIBSC_SPIDATA_ENABLE       (1u)
+
+#define SPIBSC_SPI_DISABLE          (0u)
+#define SPIBSC_SPI_ENABLE           (1u)
+
+
+/* Use for setting of the DME bit of "data read enable register"(DRENR) */
+#define SPIBSC_DUMMY_CYC_DISABLE    (0u)
+#define SPIBSC_DUMMY_CYC_ENABLE     (1u)
+
+/* Use for setting of the DMCYC [2:0] bit of "data read dummy cycle register"(DRDMCR) */
+#define SPIBSC_DUMMY_1CYC           (0u)
+#define SPIBSC_DUMMY_2CYC           (1u)
+#define SPIBSC_DUMMY_3CYC           (2u)
+#define SPIBSC_DUMMY_4CYC           (3u)
+#define SPIBSC_DUMMY_5CYC           (4u)
+#define SPIBSC_DUMMY_6CYC           (5u)
+#define SPIBSC_DUMMY_7CYC           (6u)
+#define SPIBSC_DUMMY_8CYC           (7u)
+
+/* Use for setting of "data read DDR enable register"(DRDRENR) */
+#define SPIBSC_SDR_TRANS            (0u)
+#define SPIBSC_DDR_TRANS            (1u)
+
+/* Use for setting the CKDLY regsiter */
+#define SPIBSC_CKDLY_DEFAULT        (0x0000A504uL)    /* Initial value */
+#define SPIBSC_CKDLY_TUNING         (0x0000A50AuL)    /* Shorten the data input setup time and extend the data hold time */
+
+/* Use for setting the SPODLY regsiter */
+#define SPIBSC_SPODLY_DEFAULT       (0xA5000000uL)    /* Initial value */
+#define SPIBSC_SPODLY_TUNING        (0xA5001111uL)    /* Delay the data output delay/hold/buffer-on/buffer-off time */
+
+#endif /* _SPIBSC_H_ */
+
+/* End of File */
